commit 66b305583aa04467e4f5334cd75e5e2d7e2a1a41
Author: Pavel Fidranský <fidransky@outlook.com>
Date:   Mon Aug 27 20:33:31 2018 +0200

    frontend cleanup

diff --git a/sources/src/main/webapp/css/main.css b/sources/src/main/webapp/css/main.css
index 96652de..b8f15b7 100644
--- a/sources/src/main/webapp/css/main.css
+++ b/sources/src/main/webapp/css/main.css
@@ -697,55 +697,6 @@ body {
 	top: 2em;
 }
 
-.node-container:not(.excluded-nodes) .change-button {
-    display: none;
-}
-
-.change-nodes .button-group .change-button,
-.change-nodes .button-group .change-button {
-    display: none;
-}
-
-.sidebar .change-list {
-	list-style: none;
-	margin: 0;
-	padding-left: 0;
-}
-
-.sidebar .change:not(.change--triggered) .change-controls {
-	display: none;
-}
-
-.sidebar .change:not(.change--triggered) .change-controls + .node-list {
-	display: none;
-}
-
-.sidebar .change--triggered .include-not-found-checkbox,
-.sidebar .change--triggered .trigger-change-button {
-	display: none;
-}
-
-.sidebar .change--triggered .change-controls + .node-list .include-button {
-	display: none;
-}
-
-.sidebar .change-controls {
-    position: relative;
-    text-align: center;
-}
-
-.sidebar .change-controls .transition-arrow {
-	font-size: 3em;
-}
-
-.sidebar .change-controls .load-details-button {
-	font-weight: bold;
-}
-
-.sidebar .change--details-loaded .change-controls .load-details-button {
-	display: none;
-}
-
 .unconnected-nodes .node > svg {
     display: none;
 }
@@ -754,12 +705,6 @@ body {
     display: none;
 }
 
-.missing-components .node-list > li {
-	white-space: nowrap;
-	overflow: hidden;
-	text-overflow: ellipsis;
-}
-
 .sort-list {
 	font-size: 0.8em;
 	list-style: none;
diff --git a/sources/src/main/webapp/js/components/vertexLight.js b/sources/src/main/webapp/js/components/vertexLight.js
deleted file mode 100644
index 26027d0..0000000
--- a/sources/src/main/webapp/js/components/vertexLight.js
+++ /dev/null
@@ -1,48 +0,0 @@
-/**
- * Light version of the vertex to be used inside of a change as a placeholder until full change details are loaded.
- * @see Vertex
- * @see Change
- * @constructor
- * @param {object} props Properties of the vertex.
- */
-function VertexLight(props) {
-	/** @prop {string} id Identifier of the component in CRCE. */
-	this.id = props.uuid;
-	/** @prop {string} name Name of the component. */
-	this.name = props['external-id'] + ' v' + props.version;
-
-	/**
-	 * Removes the DOM element representing the vertex from document.
-	 */
-	this.exclude = function() {
-		this.remove();
-	};
-
-	/**
-	 * Creates a new DOM element representing the vertex in memory.
-	 * @returns {Element} HTML DOM element.
-	 */
-	this.render = function() {
-		rootElement = app.utils.createHtmlElement('li', {
-			'class': 'node vertex',
-			'data-id': this.id,
-		});
-
-		// name
-		var nameText = app.utils.createHtmlElement('div', {
-			'class': 'vertex-name',
-			'title': this.name,
-		});
-		nameText.appendChild(document.createTextNode(this.name));
-		rootElement.appendChild(nameText);
-
-		return rootElement;
-	};
-	
-	/**
-	 * Removes the DOM element representing the vertex from document.
-	 */
-	this.remove = function() {
-		rootElement.remove();
-	};
-}
\ No newline at end of file
diff --git a/sources/src/main/webapp/js/legacy/diagram.js b/sources/src/main/webapp/js/legacy/diagram.js
deleted file mode 100644
index 1f03243..0000000
--- a/sources/src/main/webapp/js/legacy/diagram.js
+++ /dev/null
@@ -1,68 +0,0 @@
-/**
-* Funkce zavola servlet, ktery odstrani diagram z databáze a ze serveru.
-*
-* @param id_diagram - id diagramu
-*/
-function deleteDiagram(id_diagram) {
-	var really = confirm('Do you really want to remove diagram?');
-	if (really === false) {
-		return false;
-	}
-
-	$.ajax({
-		url: 'api/diagram?id_diagram=' + id_diagram,
-		type: 'DELETE',
-		success: function(result) {
-			$('#diagram_id_' + id_diagram).remove();
-			$('#public_diagram_id_' + id_diagram).remove();
-		},
-	});
-}
-
-/**
-* Funkce nalezne vsechny komponenty zobrazene ve viewportu, ulozi je jako json a odesle servletu.
-* 
-* @param id_diagram ID diagramu
-*/
-function saveDiagram(id_diagram) {
-	var vertex_position = new Array(),
-		vertex_position_counter = 0;
-	
-	$('g.vertex').each(function () {
-		vertex_position[vertex_position_counter] = ' {"id":"' + $(this).attr('id') + '" , ' +
-		'  "transform":"' + $(this).attr('transform') + '" }';
-		vertex_position_counter++;
-	});
-	
-	vertex_position.join(',');
-	vertex_position = '{"vertices_position": [ ' + vertex_position + ' ]}';
-	
-	$.post('api/diagram', {
-		id_diagram: id_diagram,
-		vertices_position: vertex_position,
-	}).done(function () {
-		alert("Diagram saved.");
-	}).fail(function () {
-		alert("Error - Diagram not saved!");
-	});
-}
-
-/**
-* Funkce zobrazi vyskakovaci okno s potvrzenim
-*
-* @param diagramId ID diagramu
-* @returns {Boolean} true if reset confirmed
-*/
-function reset_diagram(diagramId) {
-	var really = confirm('Do you want to reset components position and refresh page?');
-	if (really === false) {
-		return false;
-	}
-
-	$.post('api/diagram', {
-		id_diagram: diagramId,
-		vertices_position: "",
-	});
-
-	return true;
-}
\ No newline at end of file
diff --git a/sources/src/main/webapp/js/legacy/user.js b/sources/src/main/webapp/js/legacy/user.js
deleted file mode 100644
index b59fb6a..0000000
--- a/sources/src/main/webapp/js/legacy/user.js
+++ /dev/null
@@ -1,42 +0,0 @@
-
-/**
-* Funkce odesle registracni formular
-*/
-function send_register() {
-
-	// var viewport_html = $('#viewport').html();
-	// var rightpanel_html = $('#rightPanel').html();
-	
-	$.post('api/register', { user_name:  $('#user_name').val(),
-		user_email: $('#user_email').val(),
-		user_nick: $('#user_nick').val(),
-		user_password: $('#user_password').val(),
-		user_password_2: $('#user_password_2').val()},
-	function(data){
-		if (data.ok != null && data.ok == "ok"){
-			$('.register_popup .err_msg').html("");
-			$('.register_popup .err_msg').hide();
-			
-			$('.register_popup').hide();
-			$('.login_popup').show();
-			var user_login_name = $('#user_nick').val();
-			clear_register_form();
-			$('.login_popup .not_msg').html("User registered.<br />Please login.");
-			$('#login_name').val(user_login_name);
-			
-			}else if (data.err != null){
-			$('.register_popup .err_msg').html(data.err.replace(/\./g,".<br />"));
-		}
-	});
-}
-
-/**
- * Vycisti registracni formular
- */
-function clear_register_form(){
-	$('#user_name').val('');
-	$('#user_email').val('');
-	$('#user_nick').val('');
-	$('#user_password').val('');
-	$('#user_password_2').val('');
-}
\ No newline at end of file
diff --git a/sources/src/main/webapp/uploadFiles.jsp b/sources/src/main/webapp/uploadFiles.jsp
index ddc1661..fbe68bf 100644
--- a/sources/src/main/webapp/uploadFiles.jsp
+++ b/sources/src/main/webapp/uploadFiles.jsp
@@ -9,8 +9,6 @@
 		<link rel="stylesheet" href="css/main.css">
 
 		<script src="js/libs/jquery-1.8.3.js"></script>
-		<script src="js/legacy/diagram.js"></script>
-		<script src="js/legacy/user.js"></script>
 		<script src="js/userMenu.js"></script>
 
 		<title>IMiGEr</title>