commit 736838d4ca1f41b87ee10f9c356751a33233479a
Author: Patrik Harag <patrikharag@gmail.com>
Date:   Wed Apr 3 21:46:56 2019 +0200

    Cleanup sources

diff --git a/.gitignore b/.gitignore
index 5ba8ee5..ec35556 100644
--- a/.gitignore
+++ b/.gitignore
@@ -7,4 +7,3 @@ sources/imiger-core/src/main/webapp/node_modules/
 
 **/.DS_Store
 .DS_Store
-**/*.class
diff --git a/sources/classes/production/imiger-dot-converter/META-INF/services/cz.zcu.kiv.imiger.spi.IModule b/sources/classes/production/imiger-dot-converter/META-INF/services/cz.zcu.kiv.imiger.spi.IModule
deleted file mode 100644
index ec82154..0000000
--- a/sources/classes/production/imiger-dot-converter/META-INF/services/cz.zcu.kiv.imiger.spi.IModule
+++ /dev/null
@@ -1 +0,0 @@
-cz.zcu.kiv.imiger.plugin.dot.DOT
\ No newline at end of file
diff --git a/sources/classes/production/imiger-dot-converter/cz/zcu/kiv/imiger/plugin/dot/DOT.class b/sources/classes/production/imiger-dot-converter/cz/zcu/kiv/imiger/plugin/dot/DOT.class
deleted file mode 100644
index a0a1408..0000000
Binary files a/sources/classes/production/imiger-dot-converter/cz/zcu/kiv/imiger/plugin/dot/DOT.class and /dev/null differ
diff --git a/sources/classes/production/imiger-dot-converter/log4j2.properties b/sources/classes/production/imiger-dot-converter/log4j2.properties
deleted file mode 100644
index bf4c521..0000000
--- a/sources/classes/production/imiger-dot-converter/log4j2.properties
+++ /dev/null
@@ -1,18 +0,0 @@
-name=PropertiesConfig
-property.filename = logs
-appenders = console, file
-
-appender.console.type = Console
-appender.console.name = STDOUT
-appender.console.layout.type = PatternLayout
-appender.console.layout.pattern=%d{yy-MM-dd HH:mm:ss:SSS} %-6p [%c:%M:%L] - %m%n
-
-appender.file.type = File
-appender.file.name = LOGFILE
-appender.file.fileName=${filename}/propertieslogs.log
-appender.file.layout.type=PatternLayout
-appender.file.layout.pattern=%d{yy-MM-dd HH:mm:ss:SSS} %-6p [%c:%M:%L] - %m%n
-
-rootLogger.level = debug
-rootLogger.appenderRefs = stdout
-rootLogger.appenderRef.stdout.ref = STDOUT
\ No newline at end of file
diff --git a/sources/classes/test/imiger-dot-converter/complete1.dot b/sources/classes/test/imiger-dot-converter/complete1.dot
deleted file mode 100644
index 3422119..0000000
--- a/sources/classes/test/imiger-dot-converter/complete1.dot
+++ /dev/null
@@ -1,31 +0,0 @@
-digraph "example.y"
-{
-  node [fontname = courier, shape = box, colorscheme = paired6]
-  edge [fontname = courier]
-
-  0 [label="State 0\n\l  0 $accept: . exp $end\l"]
-  0 -> 1 [style=solid label="\"0\""]
-  0 -> 2 [style=dashed label="exp"]
-  0 -> 3 [style=dashed label="a"]
-  0 -> 4 [style=dashed label="b"]
-  1 [label="State 1\n\l  3 a: \"0\" .\l  4 b: \"0\" .\l"]
-  1 -> "1R3" [style=solid]
- "1R3" [label="R3", fillcolor=3, shape=diamond, styale=filled]
-  1 -> "1R4" [label="[\".\"]", style=solid]
- "1R4" [label="R4", fillcolor=3, shape=diamond, style=filled]
-  2 [label="State 2\n\l  0 $accept: exp . $end\l"]
-  2 -> 5 [style=solid label="$end"]
-  3 [label="State 3\n\l  1 exp: a . \";\"\l"]
-  3 -> 6 [style=solid label="\";\""]
-  4 [label="State 4\n\l  2 exp: b . \".\"\l"]
-  4 -> 7 [style=solid label="\".\""]
-  5 [label="State 5\n\l  0 $accept: exp $end .\l"]
-  5 -> "5R0" [style=solid]
- "5R0" [label="Acc", fillcolor=1, shape=diamond, style=filled]
-  6 [label="State 6\n\l  1 exp: a \";\" .\l"]
-  6 -> "6R1" [style=solid]
- "6R1" [label="R1", fillcolor=3, shape=diamond, style=filled]
-  7 [label="State 7\n\l  2 exp: b \".\" .\l"]
-  7 -> "7R2" [style=solid]
- "7R2" [label="R2", fillcolor=3, shape=diamond, style=filled]
-}
\ No newline at end of file
diff --git a/sources/classes/test/imiger-dot-converter/incomplete1.dot b/sources/classes/test/imiger-dot-converter/incomplete1.dot
deleted file mode 100644
index 229ebe4..0000000
--- a/sources/classes/test/imiger-dot-converter/incomplete1.dot
+++ /dev/null
@@ -1,31 +0,0 @@
-digraph "example.y"
-{
-  node [fontname = courier, shape = box, colorscheme = paired6]
-  edge [fontname = courier]
-
-  0 [label="State 0\n\l  0 $accept: . exp $end\l"]
-   -> 1 [style=solid label="\"0\""]
-  0 -> 2 [style=dashed label="exp"]
-  0 -> 3 [style=dashed label="a"]
-  0 -> 4 [style=dashed label="b"]
-  1 [label="State 1\n\l  3 a: \"0\" .\l  4 b: \"0\" .\l"]
-  1 -> "1R3" [style=solid]
- "1R3" [label="R3", fillcolor=3, shape=diamond, styale=filled]
-  1 -> "1R4" [label="[\".\"]", style=solid]
- "1R4" [label="R4", fillcolor=3, shape=diamond, style=filled]
-  2 [label="State 2\n\l  0 $accept: exp . $end\l"]
-  2 -> 5 [style=solid label="$end"]
-  3 [label="State 3\n\l  1 exp: a . \";\"\l"]
-  3 -> 6 [style=solid label="\";\""]
-  4 [label="State 4\n\l  2 exp: b . \".\"\l"]
-  4 -> 7 [style=solid label="\".\""]
-  5 [label="State 5\n\l  0 $accept: exp $end .\l"]
-  5 -> "5R0" [style=solid]
- "5R0" [label="Acc", fillcolor=1, shape=diamond, style=filled]
-  6 [label="State 6\n\l  1 exp: a \";\" .\l"]
-  6 -> "6R1" [style=solid]
- "6R1" [label="R1", fillcolor=3, shape=diamond, style=filled]
-  7 [label="State 7\n\l  2 exp: b \".\" .\l"]
-  7 -> "7R2" [style=solid]
- "7R2" [label="R2", fillcolor=3, shape=diamond, style=filled]
-}
\ No newline at end of file
diff --git a/sources/classes/test/imiger-dot-converter/incomplete2.dot b/sources/classes/test/imiger-dot-converter/incomplete2.dot
deleted file mode 100644
index f42b762..0000000
--- a/sources/classes/test/imiger-dot-converter/incomplete2.dot
+++ /dev/null
@@ -1,30 +0,0 @@
-digraph "example.y"
-{
-  node [fontname = courier, shape = box, colorscheme = paired6]
-  edge [fontname = courier]
-
-  0 -> 1 [style=solid label="\"0\""]
-  0 -> 2 [style=dashed label="exp"]
-  0 -> 3 [style=dashed label="a"]
-  0 -> 4 [style=dashed label="b"]
-  1 [label="State 1\n\l  3 a: \"0\" .\l  4 b: \"0\" .\l"]
-  1 -> "1R3" [style=solid]
- "1R3" [label="R3", fillcolor=3, shape=diamond, styale=filled]
-  1 -> "1R4" [label="[\".\"]", style=solid]
- "1R4" [label="R4", fillcolor=3, shape=diamond, style=filled]
-  2 [label="State 2\n\l  0 $accept: exp . $end\l"]
-  2 -> 5 [style=solid label="$end"]
-  3 [label="State 3\n\l  1 exp: a . \";\"\l"]
-  3 -> 6 [style=solid label="\";\""]
-  4 [label="State 4\n\l  2 exp: b . \".\"\l"]
-  4 -> 7 [style=solid label="\".\""]
-  5 [label="State 5\n\l  0 $accept: exp $end .\l"]
-  5 -> "5R0" [style=solid]
- "5R0" [label="Acc", fillcolor=1, shape=diamond, style=filled]
-  6 [label="State 6\n\l  1 exp: a \";\" .\l"]
-  6 -> "6R1" [style=solid]
- "6R1" [label="R1", fillcolor=3, shape=diamond, style=filled]
-  7 [label="State 7\n\l  2 exp: b \".\" .\l"]
-  7 -> "7R2" [style=solid]
- "7R2" [label="R2", fillcolor=3, shape=diamond, style=filled]
-}
\ No newline at end of file