commit 7561b8daef973717ff695b4a4c8d244774a6bca0
Author: Pavel Fidranský <fidransky@outlook.com>
Date:   Fri Oct 26 10:20:51 2018 +0200

    replaced logo in PNG format by SVG

diff --git a/sources/src/main/webapp/css/main.css b/sources/src/main/webapp/css/main.css
index 0bc9972..8bd89c3 100644
--- a/sources/src/main/webapp/css/main.css
+++ b/sources/src/main/webapp/css/main.css
@@ -91,7 +91,7 @@ form input[type="checkbox"] {
 .header-logo {
     float: left;
     margin: 5px 20px;
-    width: 100px;
+    height: 50px;
 }
 
 .header-title {
diff --git a/sources/src/main/webapp/images/logo.png b/sources/src/main/webapp/images/logo.png
deleted file mode 100644
index f8b2bb1..0000000
Binary files a/sources/src/main/webapp/images/logo.png and /dev/null differ
diff --git a/sources/src/main/webapp/images/logo_cs.svg b/sources/src/main/webapp/images/logo_cs.svg
new file mode 100644
index 0000000..807be6d
--- /dev/null
+++ b/sources/src/main/webapp/images/logo_cs.svg
@@ -0,0 +1,271 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   version="1.1"
+   width="538.58264"
+   height="274.96063"
+   id="svg13523">
+  <defs
+     id="defs13525">
+    <clipPath
+       id="clipPath12488">
+      <path
+         d="m 17.008,299.723 142.062,0 0,71.615 -142.062,0 0,-71.615 z"
+         id="path12490" />
+    </clipPath>
+  </defs>
+  <metadata
+     id="metadata13528">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     transform="translate(-138.676,-359.05846)"
+     id="layer1">
+    <g
+       transform="matrix(2.9930372,0,0,2.9930372,-329.91706,-961.386)"
+       id="g13654">
+      <g
+         transform="matrix(1.25,0,0,-1.25,217.23553,476.92134)"
+         id="g12480">
+        <path
+           d="M 0,0 0,-16.535 14.316,-8.264 0,0 z"
+           id="path12482"
+           style="fill:#1a4c84;fill-opacity:1;fill-rule:nonzero;stroke:none" />
+      </g>
+      <g
+         transform="matrix(1.25,0,0,-1.25,136.4849,906.51884)"
+         id="g12484">
+        <g
+           clip-path="url(#clipPath12488)"
+           id="g12486">
+          <g
+             transform="translate(17.0079,299.7234)"
+             id="g12492">
+            <path
+               d="m 0,0 20.817,12.019 c -5.815,1.946 -10,6.272 -10.074,13.749 l 10e-4,24.74 10.708,0 0,-24.208 c 0.16,-4.926 2.734,-8.033 7.767,-8.033 1.427,0 2.644,0.26 3.678,0.724 l 1.124,0.655 c 1.878,1.358 2.867,3.669 2.966,6.654 l 0,23.945 0.025,0 L 0,71.615 0,0 z"
+               id="path12494"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(88.7724,349.7574)"
+             id="g12496">
+            <path
+               d="m 0,0 4.315,0 0,-1.3 -3.014,-4.767 3.084,0 0,-1.101 -4.526,0 0,1.309 3.011,4.755 -2.87,0 L 0,0 z"
+               id="path12498"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(94.3478,342.5903)"
+             id="g12500">
+            <path
+               d="m 0,0 1.984,7.168 1.977,0 L 5.904,0 4.326,0 3.928,1.591 1.885,1.591 1.479,0 0,0 z m 4.377,8.605 -1.391,-1.08 -1.02,0 0.892,1.08 1.519,0 z m -1.489,-2.818 -0.02,0 -0.683,-3.096 1.431,0 -0.728,3.096 z"
+               id="path12502"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(101.8604,349.7574)"
+             id="g12504">
+            <path
+               d="M 0,0 2.699,0 C 4.068,0 4.606,-0.833 4.606,-2.146 4.606,-2.958 4.364,-4.25 2.61,-4.25 l -1.111,0 0,-2.918 L 0,-7.169 0,0 z m 1.499,-3.145 0.832,0 c 0.445,0 0.753,0.486 0.753,0.961 0,0.584 -0.159,1.081 -0.832,1.081 l -0.753,0 0,-2.042 z"
+               id="path12506"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(107.2196,342.5903)"
+             id="g12508">
+            <path
+               d="m 0,0 1.983,7.168 1.973,0 L 5.904,0 4.324,0 3.927,1.591 1.886,1.591 1.477,0 0,0 z m 2.884,5.787 -0.018,0 -0.685,-3.096 1.431,0 -0.728,3.096 z"
+               id="path12510"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(114.7456,349.7574)"
+             id="g12512">
+            <path
+               d="m 0,0 2.504,0 c 1.967,0 2.333,-1.31 2.333,-3.543 0,-1.102 0.169,-3.625 -2.395,-3.625 L 0,-7.168 0,0 z m 1.501,-6.067 0.727,0 c 0.91,0 1.089,0.686 1.089,2.482 0,1.32 0,2.481 -1.043,2.481 l -0.773,0 0,-4.963 z"
+               id="path12514"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(121.6075,346.1727)"
+             id="g12516">
+            <path
+               d="m 0,0 c 0,1.897 0,3.704 2.469,3.704 2.474,0 2.474,-1.807 2.474,-3.704 0,-1.877 0,-3.702 -2.474,-3.702 C 0,-3.702 0,-1.877 0,0 M 3.421,0 C 3.421,1.838 3.312,2.632 2.469,2.632 1.624,2.632 1.515,1.837 1.515,0 c 0,-1.835 0.109,-2.631 0.954,-2.631 0.843,0 0.952,0.796 0.952,2.631"
+               id="path12518"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(128.5626,346.1727)"
+             id="g12520">
+            <path
+               d="m 0,0 c 0,1.897 0,3.704 2.467,3.704 1.532,0 2.147,-0.844 2.085,-2.386 l -1.468,0 C 3.084,2.274 2.916,2.632 2.467,2.632 1.625,2.632 1.516,1.837 1.516,0 c 0,-1.835 0.108,-2.631 0.951,-2.631 0.697,0 0.666,0.896 0.687,1.462 l 1.479,0 C 4.633,-3.088 3.866,-3.702 2.467,-3.702 0,-3.702 0,-1.877 0,0 m 3.143,5.023 1.123,0 -1.004,-1.08 -1.637,0 -1,1.08 1.121,0 0.706,-0.585 0.691,0.585 z"
+               id="path12522"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(135.0403,342.5903)"
+             id="g12524">
+            <path
+               d="m 0,0 0,7.168 3.911,0 0,-1.105 -2.414,0 0,-1.766 2.227,0 0,-1.1 -2.227,0 0,-2.096 2.491,0 L 3.988,0 0,0 z"
+               id="path12526"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(142.8375,342.4706)"
+             id="g12528">
+            <path
+               d="m 0,0 c -1.853,0 -2.203,1.092 -2.12,2.332 l 1.495,0 c 0,-0.684 0.031,-1.26 0.854,-1.26 0.504,0 0.753,0.329 0.753,0.813 0,1.291 -3.016,1.372 -3.016,3.504 0,1.122 0.54,2.017 2.361,2.017 1.462,0 2.187,-0.656 2.086,-2.155 l -1.463,0 c 0,0.536 -0.085,1.083 -0.689,1.083 -0.491,0 -0.775,-0.269 -0.775,-0.765 0,-1.359 3.015,-1.24 3.015,-3.493 C 2.502,0.219 1.143,0 0,0"
+               id="path12530"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(150.4878,349.7574)"
+             id="g12532">
+            <path
+               d="m 0,0 1.651,0 -2.006,-3.216 2.006,-3.952 -1.691,0 -1.717,3.675 -0.02,0 0,-3.675 -1.495,0 0,7.168 1.495,0 0,-3.069 0.02,0 L 0,0 z"
+               id="path12534"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(153.1693,342.5903)"
+             id="g12536">
+            <path
+               d="m 0,0 1.98,7.168 1.978,0 L 5.901,0 4.324,0 3.927,1.591 1.88,1.591 1.477,0 0,0 z m 4.372,8.605 -1.39,-1.08 -1.02,0 0.895,1.08 1.515,0 z m -1.487,-2.818 -0.018,0 -0.686,-3.096 1.429,0 -0.725,3.096 z"
+               id="path12538"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(93.6463,335.4297)"
+             id="g12540">
+            <path
+               d="m 0,0 0,-5.08 c 0,-1.072 -0.607,-2.203 -2.428,-2.203 -1.65,0 -2.441,0.856 -2.441,2.203 l 0,5.08 1.496,0 0,-4.981 c 0,-0.883 0.378,-1.228 0.925,-1.228 0.65,0 0.948,0.437 0.948,1.228 L -1.5,0 0,0 z"
+               id="path12542"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(95.7668,328.2652)"
+             id="g12544">
+            <path
+               d="m 0,0 0,7.165 2.024,0 1.902,-4.963 0.018,0 0,4.963 1.399,0 L 5.343,0 3.372,0 1.421,5.239 1.398,5.239 1.398,0 0,0 z"
+               id="path12546"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <path
+             d="m 103.268,328.266 1.496,0 0,7.165 -1.496,0 0,-7.165 z"
+             id="path12548"
+             style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          <g
+             transform="translate(106.3413,335.4297)"
+             id="g12550">
+            <path
+               d="m 0,0 1.559,0 1.106,-5.208 0.021,0 L 3.937,0 5.414,0 3.521,-7.165 1.764,-7.165 0,0 z"
+               id="path12552"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(113.3178,328.2652)"
+             id="g12554">
+            <path
+               d="m 0,0 0,7.165 3.916,0 0,-1.104 -2.416,0 0,-1.763 2.226,0 0,-1.102 -2.226,0 0,-2.093 2.49,0 L 3.99,0 0,0 z"
+               id="path12556"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(120.641,328.2652)"
+             id="g12558">
+            <path
+               d="m 0,0 -1.497,0 0,7.165 2.767,0 c 1.022,0 1.672,-0.657 1.672,-1.875 0,-0.912 -0.354,-1.597 -1.328,-1.756 l 0,-0.022 C 1.946,3.471 2.915,3.394 2.915,2.106 2.915,1.65 2.942,0.298 3.084,0.001 L 1.614,0 C 1.421,0.439 1.458,0.925 1.458,1.392 1.458,2.243 1.539,2.97 0.388,2.97 L 0.002,2.97 0.002,0 0,0 z m 0,4.07 0.663,0 c 0.599,0 0.767,0.594 0.767,1.051 0,0.684 -0.288,0.94 -0.767,0.94 L 0,6.061 0,4.07 z"
+               id="path12560"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(125.3113,335.4297)"
+             id="g12562">
+            <path
+               d="m 0,0 4.314,0 0,-1.298 -3.013,-4.763 3.083,0 0,-1.104 -4.52,0 0,1.307 3.004,4.755 L 0,-1.103 0,0 z"
+               id="path12564"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <path
+             d="m 131.433,328.266 1.499,0 0,7.165 -1.499,0 0,-7.165 z"
+             id="path12566"
+             style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          <g
+             transform="translate(139.3434,335.4297)"
+             id="g12568">
+            <path
+               d="m 0,0 0,-1.193 -1.665,0 0,-5.972 -1.497,0 0,5.972 -1.666,0 0,1.193 L 0,0 z"
+               id="path12570"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(139.7932,328.2652)"
+             id="g12572">
+            <path
+               d="m 0,0 1.985,7.165 1.971,0 L 5.899,0 4.325,0 3.927,1.589 1.885,1.589 1.478,0 0,0 z m 2.891,5.785 -0.021,0 -0.69,-3.095 1.427,0 -0.716,3.095 z"
+               id="path12574"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(88.4902,321.1019)"
+             id="g12576">
+            <path
+               d="m 0,0 1.556,0 1.11,-5.201 0.018,0 L 3.93,0 5.406,0 3.515,-7.15 1.762,-7.15 0,0 z"
+               id="path12578"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(98.5646,321.1019)"
+             id="g12580">
+            <path
+               d="M 0,0 2.688,0 C 4.056,0 4.59,-0.832 4.59,-2.139 4.59,-2.952 4.353,-4.238 2.597,-4.238 l -1.108,0 0,-2.913 -1.49,0 0,7.151 L 0,0 z m 1.489,-3.14 0.833,0 c 0.447,0 0.754,0.488 0.754,0.962 0,0.588 -0.155,1.081 -0.834,1.081 l -0.753,-0.001 0,-2.042 z"
+               id="path12582"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(104.2147,313.9511)"
+             id="g12584">
+            <path
+               d="m 0,0 0,7.15 1.497,0 0,-5.957 2.237,0 L 3.734,0 0,0 z"
+               id="path12586"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(109.2236,321.1019)"
+             id="g12588">
+            <path
+               d="m 0,0 4.308,0 0,-1.298 -3.008,-4.753 3.08,0 0,-1.099 -4.517,0 0,1.306 3.001,4.746 L 0,-1.098 0,0 z"
+               id="path12590"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <g
+             transform="translate(115.3422,313.9511)"
+             id="g12592">
+            <path
+               d="m 0,0 0,7.15 2.024,0 1.901,-4.951 0.021,0 0,4.951 1.392,0 L 5.338,0 3.368,0 1.416,5.229 1.4,5.229 1.4,0 0,0 z"
+               id="path12594"
+               style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+          </g>
+          <path
+             d="m 122.83,313.95 1.496,0 0,7.151 -1.496,0 0,-7.151 z"
+             id="path12596"
+             style="fill:#1a4c84;fill-opacity:1;fill-rule:evenodd;stroke:none" />
+        </g>
+      </g>
+    </g>
+  </g>
+</svg>
diff --git a/sources/src/main/webapp/js/components/header.js b/sources/src/main/webapp/js/components/header.js
index 0b8ea54..cbb8e62 100644
--- a/sources/src/main/webapp/js/components/header.js
+++ b/sources/src/main/webapp/js/components/header.js
@@ -20,7 +20,7 @@ class Header {
 			class: 'header',
 		}, [
 			DOM.h('img', {
-				src: 'images/logo.png',
+				src: 'images/logo_cs.svg',
 				class: 'header-logo',
 				alt: 'logo of University of West Bohemia',
 				title: 'University of West Bohemia',
diff --git a/sources/src/main/webapp/uploadFiles.jsp b/sources/src/main/webapp/uploadFiles.jsp
index b237c4d..65e00a9 100644
--- a/sources/src/main/webapp/uploadFiles.jsp
+++ b/sources/src/main/webapp/uploadFiles.jsp
@@ -40,7 +40,7 @@
 
 	<body class="${isLoggedIn ? 'loggedIn' : 'loggedOut'}">
 		<header class="header" id="header">
-			<img src="images/logo.png" class="header-logo" alt="logo of University of West Bohemia" title="University of West Bohemia">
+			<img src="images/logo_cs.svg" class="header-logo" alt="logo of University of West Bohemia" title="University of West Bohemia">
 
 			<h2 class="header-title">Interactive Multimodal Graph Explorer</h2>
 